diff --git a/guix/scripts/archive.scm b/guix/scripts/archive.scm
index 2b5a55a23f4..480c13904fd 100644
--- a/guix/scripts/archive.scm
+++ b/guix/scripts/archive.scm
@@ -1,6 +1,7 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2013, 2014, 2015, 2016, 2017, 2019, 2020, 2021 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2020 Tobias Geerinckx-Rice <me@tobias.gr>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -91,7 +92,8 @@ (define (show-help)
   (display (G_ "
   -S, --source           build the packages' source derivations"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
 
   (newline)
   (show-build-options-help)
diff --git a/guix/scripts/build.scm b/guix/scripts/build.scm
index 05f022a92e2..366e782470f 100644
--- a/guix/scripts/build.scm
+++ b/guix/scripts/build.scm
@@ -3,6 +3,7 @@
 ;;; Copyright © 2013 Mark H Weaver <mhw@netris.org>
 ;;; Copyright © 2020 Marius Bakke <mbakke@fastmail.com>
 ;;; Copyright © 2020 Ricardo Wurmus <rekado@elephly.net>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -184,7 +185,8 @@ (define (show-build-options-help)
   (display (G_ "
   -M, --max-jobs=N       allow at most N build jobs"))
   (display (G_ "
-      --debug=LEVEL      produce debugging output at LEVEL")))
+      --debug=LEVEL      produce debugging output at LEVEL, value must be an integer
+      between 0 (more terse) and 5 (more verbose)")))
 
 (define (show-cross-build-options-help)
   (display (G_ "
@@ -452,7 +454,8 @@ (define (show-help)
   -r, --root=FILE        make FILE a symlink to the result, and register it
                          as a garbage collector root"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
   -q, --quiet            do not show the build log"))
   (display (G_ "
diff --git a/guix/scripts/copy.scm b/guix/scripts/copy.scm
index 67975ac1a9b..ed64d04abb8 100644
--- a/guix/scripts/copy.scm
+++ b/guix/scripts/copy.scm
@@ -1,5 +1,6 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2016, 2017, 2019, 2020, 2021 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -120,7 +121,8 @@ (define (show-help)
   (display (G_ "
       --from=HOST        receive ITEMS from HOST"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (newline)
   (show-build-options-help)
   (newline)
diff --git a/guix/scripts/deploy.scm b/guix/scripts/deploy.scm
index 4b1a6030497..350cc1d3395 100644
--- a/guix/scripts/deploy.scm
+++ b/guix/scripts/deploy.scm
@@ -2,6 +2,7 @@
 ;;; Copyright © 2019 David Thompson <davet@gnu.org>
 ;;; Copyright © 2019 Jakob L. Kreuze <zerodaysfordays@sdf.org>
 ;;; Copyright © 2020-2022 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -62,7 +63,8 @@ (define (show-help)
   -x, --execute          execute the following command on all the machines"))
   (newline)
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (show-bug-report-information))
 
 (define %options
diff --git a/guix/scripts/environment.scm b/guix/scripts/environment.scm
index 6ae3b11e393..3fce43ad25c 100644
--- a/guix/scripts/environment.scm
+++ b/guix/scripts/environment.scm
@@ -3,6 +3,7 @@
 ;;; Copyright © 2015-2023 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2018 Mike Gerwitz <mtg@gnu.org>
 ;;; Copyright © 2022, 2023 John Kehayias <john.kehayias@protonmail.com>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -131,7 +132,8 @@ (define (show-environment-options-help)
   -S, --symlink=SPEC     for containers, add symlinks to the profile according
                          to SPEC, e.g. \"/usr/bin/env=bin/env\"."))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
       --bootstrap        use bootstrap binaries to build the environment")))
 
diff --git a/guix/scripts/home.scm b/guix/scripts/home.scm
index b4c82d275f1..3abd0fcbc5d 100644
--- a/guix/scripts/home.scm
+++ b/guix/scripts/home.scm
@@ -6,6 +6,7 @@
 ;;; Copyright © 2022-2023 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2022 Arun Isaac <arunisaac@systemreboot.net>
 ;;; Copyright © 2022 Antero Mejr <antero@mailbox.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -137,7 +138,8 @@ (define (show-help)
                          according to SPEC"))
   (newline)
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
       --graph-backend=BACKEND
                          use BACKEND for 'extension-graph' and 'shepherd-graph'"))
diff --git a/guix/scripts/install.scm b/guix/scripts/install.scm
index 504dbc9a6f6..a1036c16a66 100644
--- a/guix/scripts/install.scm
+++ b/guix/scripts/install.scm
@@ -1,5 +1,6 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2019, 2020 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -35,7 +36,8 @@ (define (show-help)
   -p, --profile=PROFILE  use PROFILE instead of the user's default profile"))
   ;; '--bootstrap' not shown here.
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (newline)
   (show-build-options-help)
   (newline)
diff --git a/guix/scripts/pack.scm b/guix/scripts/pack.scm
index bdbea49910c..eac3c422730 100644
--- a/guix/scripts/pack.scm
+++ b/guix/scripts/pack.scm
@@ -8,6 +8,7 @@
 ;;; Copyright © 2020, 2021, 2022, 2023 Maxim Cournoyer <maxim.cournoyer@gmail.com>
 ;;; Copyright © 2020 Eric Bavier <bavier@posteo.net>
 ;;; Copyright © 2022 Alex Griffin <a@ajgrf.com>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -1493,7 +1494,8 @@ (define (show-help)
   (display (G_ "
   -d, --derivation       return the derivation of the pack"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
       --bootstrap        use the bootstrap binaries to build the pack"))
   (newline)
diff --git a/guix/scripts/package.scm b/guix/scripts/package.scm
index a489e06e731..dc394d0738c 100644
--- a/guix/scripts/package.scm
+++ b/guix/scripts/package.scm
@@ -13,6 +13,7 @@
 ;;; Copyright © 2022 Josselin Poiret <dev@jpoiret.xyz>
 ;;; Copyright © 2022 Arun Isaac <arunisaac@systemreboot.net>
 ;;; Copyright © 2022 Antero Mejr <antero@mailbox.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -476,7 +477,8 @@ (define (show-help)
   (display (G_ "
       --bootstrap        use the bootstrap Guile to build the profile"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (newline)
   (display (G_ "
   -s, --search=REGEXP    search in synopsis and description using REGEXP"))
diff --git a/guix/scripts/pull.scm b/guix/scripts/pull.scm
index 58d3cd7e83c..77e6ebd96a1 100644
--- a/guix/scripts/pull.scm
+++ b/guix/scripts/pull.scm
@@ -2,6 +2,7 @@
 ;;; Copyright © 2013-2015, 2017-2023 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2017 Marius Bakke <mbakke@fastmail.com>
 ;;; Copyright © 2020, 2021 Tobias Geerinckx-Rice <me@tobias.gr>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -116,7 +117,8 @@ (define (show-help)
   (display (G_ "
   -p, --profile=PROFILE  use PROFILE instead of ~/.config/guix/current"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
       --bootstrap        use the bootstrap Guile to build the new Guix"))
   (newline)
diff --git a/guix/scripts/remove.scm b/guix/scripts/remove.scm
index be073878c58..f5a5c3dc539 100644
--- a/guix/scripts/remove.scm
+++ b/guix/scripts/remove.scm
@@ -1,5 +1,6 @@
 ;;; GNU Guix --- Functional package management for GNU
 ;;; Copyright © 2019, 2020 Ludovic Courtès <ludo@gnu.org>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -34,7 +35,8 @@ (define (show-help)
   -p, --profile=PROFILE  use PROFILE instead of the user's default profile"))
   ;; '--bootstrap' not shown here.
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (newline)
   (show-build-options-help)
   (newline)
diff --git a/guix/scripts/system.scm b/guix/scripts/system.scm
index f85b663d643..562a3abb166 100644
--- a/guix/scripts/system.scm
+++ b/guix/scripts/system.scm
@@ -11,6 +11,7 @@
 ;;; Copyright © 2021 Brice Waegeneire <brice@waegenei.re>
 ;;; Copyright © 2021 Simon Tournier <zimon.toutoune@gmail.com>
 ;;; Copyright © 2022 Tobias Geerinckx-Rice <me@tobias.gr>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -1038,7 +1039,8 @@ (define (show-help)
   (display (G_ "
       --skip-checks      skip file system and initrd module safety checks"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (newline)
   (display (G_ "
       --graph-backend=BACKEND
diff --git a/guix/scripts/upgrade.scm b/guix/scripts/upgrade.scm
index 1a5e8088cb1..483b5c12163 100644
--- a/guix/scripts/upgrade.scm
+++ b/guix/scripts/upgrade.scm
@@ -2,6 +2,7 @@
 ;;; Copyright © 2019, 2020 Ludovic Courtès <ludo@gnu.org>
 ;;; Copyright © 2020 Jakub Kądziołka <kuba@kadziolka.net>
 ;;; Copyright © 2020 Simon Tournier <zimon.toutoune@gmail.com>
+;;; Copyright © 2023 Wilko Meyer <w@wmeyer.eu>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -37,7 +38,8 @@ (define (show-help)
   (display (G_ "
   -p, --profile=PROFILE  use PROFILE instead of the user's default profile"))
   (display (G_ "
-  -v, --verbosity=LEVEL  use the given verbosity LEVEL"))
+  -v, --verbosity=LEVEL  use the given verbosity LEVEL, value must be either 0 (no output),
+  1 (quiet), 2 (quiet + download URLs) or 3 (build log on STDERR)"))
   (display (G_ "
       --do-not-upgrade[=REGEXP] do not upgrade any packages matching REGEXP"))
   (newline)